package JIP;

import java.awt.*;
import JIP.engine.*;
import Ugosoft.awt.*;

import java.io.*;


public class JIProlog implements JIPEventListener, JIPErrorListener
{	
	private static Frame frame = new Frame();
	
	// application
	public static void main(String args[])
    {        
		frame.setIconImage(Toolkit.getDefaultToolkit().getImage(frame.getClass().getResource("/icoJip.gif")));
        JIProlog prolog = new JIProlog();
        prolog.start(args[0]);
    }		        
    
    synchronized void start(String strFileName)
    {
        String strBasePath = "file:/" + System.getProperties().getProperty("user.dir") + "/";

        // New instance of prolog engine
        JIPEngine prolog = new JIPEngine(frame, strBasePath, null, System.out);               
        prolog.addEventListener(this);
                
        try
        {
			prolog.consultFile(strFileName);                    
            JIPTerm mainQuery = JIPTerm.parseQuery("main.");
            prolog.openQuery(mainQuery);
            wait();                         
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }               
    }
    
    // A Start event occurred
    public void openNotified(JIPEvent e)
    {}
    
    public void moreNotified(JIPEvent e)
    {}
    
    // A solution event occurred    
    public synchronized void solutionNotified(JIPEvent e)
    {           
        MessageDialog msgbox = new MessageDialog(frame, "JIP Interpreter", "Bye Bye. Thanks for using JIP.");      
        msgbox.show();        
        msgbox = new MessageDialog(frame, "JIP Interpreter", "JIP - Java Internet Prolog, by Ugo Chirico.");
        msgbox.show();
        e.getSource().closeQuery(e.getQueryHandle());
    }
    
    // A Term has been notified with notify/2
    public void termNotified(JIPEvent e)
    {}
    
    // The end has been reached because there wasn't more solutions
    public void endNotified(JIPEvent e)
    {        
        MessageDialog msgbox = new MessageDialog(frame, "JIP Interpreter", "Thanks for using JIP.");
        msgbox.show();        
        msgbox = new MessageDialog(frame, "JIP Interpreter", "JIP - Java Internet Prolog By Ugo Chirico.");
        msgbox.show();        
        e.getSource().closeQuery(e.getQueryHandle());
    }
    
    public void closeNotified(JIPEvent e)
    {
		System.exit(0);
	}

    // An error (exception) has been raised up by prolog engine
    public void errorNotified(JIPErrorEvent e)
    {
        MessageDialog msgbox = new MessageDialog(frame, "JIP Interpreter", e.getError());
        msgbox.show();
        System.out.println("Error:");
        System.out.println(e.getError());
        System.exit(0);            
    }    
}