package JIP;

import JIP.engine.*;
import java.util.Enumeration;
import java.io.*;

public class TextClausesDatabase extends JIPClausesDatabase
{
    public final static String SEPARATOR = "#";
    
    private PrintWriter m_writer;
    private String      m_strFileName;
    
    public TextClausesDatabase()
    {
        super();
    }

    public String getFileName()
    {
        return m_strFileName;
    }
    
    public void setAttributes(String strAttribs)
    {
        m_strFileName = strAttribs;
    }
    
    public synchronized boolean addClauseAt(int nPos, JIPClause clause)
    {
        return false;
    }
    
    public synchronized boolean addClause(JIPClause clause)
    {
        try
        {
            m_writer = new PrintWriter(new FileWriter(m_strFileName, true));        
        }
        catch(IOException ex)
        {
            throw new RuntimeException(ex.getMessage());
        }
        
        // extracts the functor
        JIPFunctor fun = clause.getFunctor();
        
        // get the parameters      
        JIPList params = fun.getParams();
        
        String strLine = "";
            
        JIPList tail = params;
        
        while(tail != null)
        {
            JIPTerm head = tail.getHead();  
            strLine += head.toString() + SEPARATOR;
            tail = tail.getTail();  
        }        
                       
        m_writer.println(strLine);
        m_writer.flush();            
        m_writer.close();            
       
        return true;
    }
    
    public synchronized boolean removeClause(JIPClause clause)
    {
        return false;
    }
    
    public synchronized Enumeration clauses()
    {
        return new TextClausesEnumeration(this);
    }
    
    public void finalize()
    {
        m_writer.close();        
    }
}